diff --git a/sudoers.cat b/sudoers.cat
index 9adeec73b..1e4c85a73 100644
--- a/sudoers.cat
+++ b/sudoers.cat
@@ -1,155 +1,279 @@
 
 
 
-sudoers(5)                 FILE FORMATS                sudoers(5)
+SUDOERS(5)                 FILE FORMATS                SUDOERS(5)
 
 
 NNNNAAAAMMMMEEEE
-       sudoers - list of which users may execute what as root
+       sudoers - list of which users may execute what
 
 DDDDEEEESSSSCCCCRRRRIIIIPPPPTTTTIIIIOOOONNNN
-       The _s_u_d_o_e_r_s file is composed of an optional host alias
-       section, an optional command alias section and the user
-       specification section.  All command or host aliases need
-       to start with their respective keywords (ie: Host_Alias,
-       User_Alias, Runas_Alias or Cmnd_Alias).  If there are
-       multiple occurrences of a user, the logical union of the
-       entries will be used.  Note that if there is an entry that
-       denies access to a command that is followed by an entry
-       that grants access the user will be allowed to run the
-       command.
+       The _s_u_d_o_e_r_s file is composed two types of entries: aliases
+       (basically variables) and user specifications (which
+       specify who may run what).  The grammar of _s_u_d_o_e_r_s will be
+       described below in Extended Backus-Naur Form (EBNF).
+       Don't despair if you don't know what EBNF is, it is fairly
+       simple and the definitions below are annotated.
 
-       uuuusssseeeerrrr ssssppppeeeecccciiiiffffiiiiccccaaaattttiiiioooonnnn ffffoooorrrrmmmmaaaatttt::::
+       QQQQuuuuiiiicccckkkk gggguuuuiiiiddddeeee ttttoooo EEEEBBBBNNNNFFFF
 
+       EBNF is a concise and exact way of describing the grammar
+       of a language.  Each EBNF definition is made up of
+       _p_r_o_d_u_c_t_i_o_n _r_u_l_e_s.  Eg.
 
-         user access_group [: access_group] ...
+        symbol ::= definition | alternate1 | alternate2 ...
 
-           access_group ::= host-list = [(runas-list)] [NOPASSWD:] [op]cmnd_type
-                            [,[(user-list)] [NOPASSWD|PASSWD:] [op]cmnd_type] ...
-              cmnd_type ::= a command OR a command alias.
-                     op ::= the logical "!" NOT operator.
+       Each _p_r_o_d_u_c_t_i_o_n _r_u_l_e references others and thus makes up a
+       grammar for the language.  EBNF also contains the
+       following operators, which many readers will recognize
+       from regular expressions.  Do not, however, confuse them
+       with "wildcard" characters, which have different meanings.
 
+       ?       Means that the preceding symbol (or group of
+               symbols) is optional.  That is, it may appear once
+               or not at all.
 
-       hhhhoooosssstttt aaaalllliiiiaaaassss sssseeeeccccttttiiiioooonnnn ffffoooorrrrmmmmaaaatttt::::
+       *       Means that the preceding symbol (or group of
+               symbols) may appear zero or more times.
 
+       +       Means that the preceding symbol (or group of
+               symbols) may appear one or more times.
 
-         Host_Alias HOSTALIAS = host-list
+       Parentheses may be used to group symbols together.  For
+       clarity, we will use single quotes ('') to designate what
+       is a verbatim character string (as opposed to a symbol
+       name).
 
-             Host_Alias ::= a keyword.
-              HOSTALIAS ::= an upper-case alias name.
-              host-list ::= a comma separated list of hosts, netgroups,
-                            ip addresses, networks.  A logical "!"
-                            NOT operator may be prefixed to any of these.
+       AAAAlllliiiiaaaasssseeeessss
 
+       There are four kinds of aliases: the User_Alias,
+       Runas_Alias, Host_Alias and Cmnd_Alias.
 
-       uuuusssseeeerrrr aaaalllliiiiaaaassss sssseeeeccccttttiiiioooonnnn ffffoooorrrrmmmmaaaatttt::::
+        Alias ::= User_Alias = User_Alias (':' User_Alias)* |
+                  Runas_Alias (':' Runas_Alias)* |
+                  Host_Alias (':' Host_Alias)* |
+                  Cmnd_Alias (':' Cmnd_Alias)*
 
+        User_Alias ::= NAME '=' User_List
 
-         User_Alias USERALIAS = user-list
-
-             User_Alias ::= a keyword.
-              USERALIAS ::= an upper-case alias name.
-              user-list ::= a comma separated list of users, groups, netgroups.
-                            A logical "!" NOT operator may be prefixed to any
-                            of these.
-
-
-       rrrruuuunnnnaaaassss aaaalllliiiiaaaassss sssseeeeccccttttiiiioooonnnn ffffoooorrrrmmmmaaaatttt::::
-
-
-         Runas_Alias RUNASALIAS = runas-list
+        Runas_Alias ::= NAME '=' Runas_User_List
 
 
 
-22/Jun/1999                    1.6                              1
+
+25/Aug/1999                    1.6                              1
 
 
 
 
 
-sudoers(5)                 FILE FORMATS                sudoers(5)
+SUDOERS(5)                 FILE FORMATS                SUDOERS(5)
 
 
-             Runas_Alias ::= a keyword.
-              RUNASALIAS ::= an upper-case alias name.
-              runas-list ::= a comma separated list of users, groups, netgroups.
-                             A logical "!" NOT operator may be prefixed to any
-                             of these.
+        Host_Alias ::= NAME '=' Host_List
 
+        Cmnd_Alias ::= NAME '=' Cmnd_List
 
-       ccccoooommmmmmmmaaaannnndddd aaaalllliiiiaaaassss sssseeeeccccttttiiiioooonnnn ffffoooorrrrmmmmaaaatttt::::
+        NAME ::= [A-Z]([A-Z][0-9]_)*
 
+       Each _a_l_i_a_s definition is of the form
 
-         Cmnd_Alias CMNDALIAS = cmnd-list
+        Alias_Type NAME = item1, item2, ...
 
-             Cmnd_Alias ::= a keyword.
-              CMNDALIAS ::= an upper-case alias name.
-              cmnd-list ::= a comma separated list commands.
-                            A logical "!" NOT operator may be prefixed to any
-                            of these.
+       where _A_l_i_a_s___T_y_p_e is one of User_Alias, Runas_Alias,
+       Host_Alias, or Cmnd_Alias.  A NAME is a string of upper
+       case letters, numbers, and the underscore characters
+       ('_').  A NAME mmmmuuuusssstttt start with an upper case letter.  It
+       is possible to put several alias definitions of the same
+       type on a single line, joined by a semicolon (':').  Eg.
 
+        Alias_Type NAME = item1, item2, item3 : NAME = item4, item5
 
-       ccccoooommmmmmmmaaaannnndddd ssssppppeeeecccciiiiffffiiiiccccaaaattttiiiioooonnnn::::
+       The definitions of what constitutes a valid _a_l_i_a_s member
+       follow.
 
+        User_List ::= User |
+                      User ',' User_List
 
-         path arg1 arg2 .. argn = command
+        User ::= '!'* username |
+                 '!'* '#'uid |
+                 '!'* '%'group |
+                 '!'* '+'netgroup |
+                 '!'* User_Alias
 
-                   path ::= a fully qualified pathname.
-              arg[1..n] ::= optional command line arguments.
+       A User_List is made up of one or more usernames, uids
+       (prefixed with '#'), System groups (prefixed with '%'),
+       netgroups (prefixed with '+') and other aliases.  Each
+       list item may be prefixed with one or more '!' operators.
+       An odd number of '!' operators negates the value of the
+       item; an even number just cancel each other out.
 
+        Runas_List ::= Runas_User |
+                       Runas_User ',' Runas_List
 
-       ppppeeeerrrrssssiiiisssstttteeeennnncccceeee ooooffff mmmmooooddddiiiiffffiiiieeeerrrrssss
+        Runas_User ::= '!'* username |
+                       '!'* '#'uid |
+                       '!'* '%'group |
+                       '!'* +netgroup |
+                       '!'* Runas_Alias
 
-       When a _r_u_n_a_s_-_l_i_s_t is specified for an _a_c_c_e_s_s___g_r_o_u_p, it
-       affects all commands in the _a_c_c_e_s_s___g_r_o_u_p.  For example,
-       given:
+       Likewise, a Runas_List has the same possible elements as a
+       User_List, except that it can include a Runas_Alias,
+       instead of a User_Alias.
 
-           oper bigserver = (root, sysadm) /usr/bin/kill, /bin/rm
-
-       User oper will be able to run /usr/bin/kill and /bin/rm as
-       rrrrooooooootttt or ssssyyyyssssaaaaddddmmmm on the machine, bigserver.  The _r_u_n_a_s_-_l_i_s_t
-       is "sticky" across entries in the comma-separated
-       _a_c_c_e_s_s___g_r_o_u_p.  You can override the _r_u_n_a_s_-_l_i_s_t with
-       another one, at which point the new _r_u_n_a_s_-_l_i_s_t becomes the
-       default for that _a_c_c_e_s_s___g_r_o_u_p.  For example, given:
-
-           oper bigserver = (root, sysadm) /usr/bin/kill, (root) /bin/rm, \
-               /bin/rmdir
-
-       User oper can still run /usr/bin/kill as rrrrooooooootttt or ssssyyyyssssaaaaddddmmmm
-       but can only run /bin/rm and /bin/rmdir as rrrrooooooootttt.
-
-       Similarly, the NNNNOOOOPPPPAAAASSSSSSSSWWWWDDDD modifier is also persistent across
-       an _a_c_c_e_s_s___g_r_o_u_p. For example given:
-
-           oper bigserver = NOPASSWD: /usr/bin/kill, /bin/rm, /bin/rmdir
+        Host_List ::= Host |
+                      Host ',' Host_List
 
 
 
 
-22/Jun/1999                    1.6                              2
+25/Aug/1999                    1.6                              2
 
 
 
 
 
-sudoers(5)                 FILE FORMATS                sudoers(5)
+SUDOERS(5)                 FILE FORMATS                SUDOERS(5)
 
 
-       User oper will be able to run /usr/bin/kill, /bin/rm, and
-       /bin/rmdir as rrrrooooooootttt without a password.  If we change that
-       to:
+        Host ::= '!'* hostname |
+                 '!'* ip_addr |
+                 '!'* network(/netmask)? |
+                 '!'* '+'netgroup |
+                 '!'* Host_Alias
 
-           oper bigserver = NOPASSWD: /usr/bin/kill, PASSWD: /bin/rm, /bin/rmdir
+       A Host_List is made up of one or more hostnames, IP
+       addresses, network numbers, netgroups (prefixed with '+')
+       and other aliases.  Again, the value of an item may be
+       negated with the '!' operator.  If you do not specify a
+       netmask with a network number, the netmask of the host's
+       ethernet _i_n_t_e_r_f_a_c_e(s) will be used when matching.  The
+       netmask may be specified either in dotted quad notation
+       (eg.  255.255.255.0) or CIDR notation (number of bits, eg.
+       24).
 
-       User oper can still run /usr/bin/kill without a password
-       but must give a password to run /bin/rm and /bin/rmdir.
+        Cmnd_List ::= Cmnd |
+                      Cmnd ',' Cmnd_List
 
-       wwwwiiiillllddddccccaaaarrrrddddssss ((((aaaakkkkaaaa mmmmeeeettttaaaa cccchhhhaaaarrrraaaacccctttteeeerrrrssss))))::::
+        commandname ::= filename |
+                        filename args |
+                        filename '""'
 
-       ssssuuuuddddoooo allows shell-style _w_i_l_d_c_a_r_d_s along with command
-       arguments in the _s_u_d_o_e_r_s file.  Wildcard matching is done
-       via the PPPPOOOOSSSSIIIIXXXX fnmatch(3) routine.
+        Cmnd ::= '!'* commandname |
+                 '!'* directory |
+                 '!'* Cmnd_Alias
+
+       A Cmnd_List is a list of one or more commandnames,
+       directories, and other aliases.  A commandname is a fully-
+       qualified filename which may include shell-style wildcards
+       (see `Wildcards' section below).  A simple filename allows
+       the user to run the command with any arguments he/she
+       wishes.  However, you may also command line arguments
+       (including wildcards).  Alternately, you can specify "" to
+       indicate that the command may only be run wwwwiiiitttthhhhoooouuuutttt command
+       line arguments.  A directory is a fully qualified pathname
+       ending in a '/'.  When you specify a directory in a
+       Cmnd_List, the user will be able to run any file within
+       that directory (but not in any subdirectories therein).
+
+       If a Cmnd has associated command line arguments, then the
+       arguments in the Cmnd must match exactly those given by
+       the user on the command line (or match the wildcards if
+       there are any).  Note that the following characters must
+       be escaped with a '\' if they are used in command
+       arguments: ',', ':', '=', '\\'.
+
+       UUUUsssseeeerrrr SSSSppppeeeecccciiiiffffiiiiccccaaaattttiiiioooonnnn
+
+
+        Runas_Spec ::= '(' Runas_List ')'
+
+        Cmnd_Spec ::= Runas_Spec? ('NOPASSWD:' | 'PASSWD:')? Cmnd
+
+
+
+
+25/Aug/1999                    1.6                              3
+
+
+
+
+
+SUDOERS(5)                 FILE FORMATS                SUDOERS(5)
+
+
+        Cmnd_Spec_List ::= Cmnd_Spec |
+                           Cmnd_Spec ',' Cmnd_Spec_List
+
+        User_Spec ::= User_list Cmnd_Spec_List (':' User_Spec)*
+
+       A uuuusssseeeerrrr ssssppppeeeecccciiiiffffiiiiccccaaaattttiiiioooonnnn determines which commands a user may
+       run (and as what user) on specified hosts.  By default,
+       commands are run as rrrrooooooootttt but this can be changed on a per-
+       command basis.
+
+       Let's break that down into its constituent parts:
+
+       RRRRuuuunnnnaaaassss____SSSSppppeeeecccc
+
+       A Runas_Spec is simply a Runas_List (as defined above)
+       enclosed in a set of parentheses.  If you do not specify a
+       Runas_Spec in the user specification, a default Runas_Spec
+       of rrrrooooooootttt will be used.  A Runas_Spec sets the default for
+       commands that follow it.  What this means is that for the
+       entry:
+
+        dgb    boulder = (operator) /bin/ls, /bin/kill, /usr/bin/who
+
+       The user ddddggggbbbb may run _/_b_i_n_/_l_s, _/_b_i_n_/_k_i_l_l, and _/_u_s_r_/_b_i_n_/_l_p_r_m
+       -- but only as ooooppppeeeerrrraaaattttoooorrrr.  Eg.
+
+           sudo -u operator /bin/ls.
+
+       It is also possible to override a Runas_Spec later on in
+       an entry.  If we modify the entry like so:
+
+        dgb    boulder = (operator) /bin/ls, (root) /bin/kill, /usr/bin/lprm
+
+       Then user ddddggggbbbb is now allowed to run _/_b_i_n_/_l_s as ooooppppeeeerrrraaaattttoooorrrr,
+       but  _/_b_i_n_/_k_i_l_l and _/_u_s_r_/_b_i_n_/_l_p_r_m as rrrrooooooootttt.
+
+       NNNNOOOOPPPPAAAASSSSSSSSWWWWDDDD aaaannnndddd PPPPAAAASSSSSSSSWWWWDDDD
+
+       By default, ssssuuuuddddoooo requires that a user authenticate him or
+       herself before running a command.  This behavior can be
+       modified via the NOPASSWD tag.  Like a Runas_Spec, the
+       NOPASSWD tag sets a default for the commands that follow
+       it in the Cmnd_Spec_List.  Conversely, the PASSWD tag can
+       be used to reverse things.  For example:
+
+        ray    rushmore = NOPASSWD: /bin/kill, /bin/ls, /usr/bin/lprm
+
+       would allow the user rrrraaaayyyy to run _/_b_i_n_/_k_i_l_l, _/_b_i_n_/_l_s, and
+       _/_u_s_r_/_b_i_n_/_l_p_r_m as root on the machine rushmore as rrrrooooooootttt
+       without authenticating himself.  If we only want rrrraaaayyyy to be
+       able to run _/_b_i_n_/_k_i_l_l without a password the entry would
+       be:
+
+        ray    rushmore = NOPASSWD: /bin/kill, PASSWD: /bin/ls, /usr/bin/lprm
+
+
+
+25/Aug/1999                    1.6                              4
+
+
+
+
+
+SUDOERS(5)                 FILE FORMATS                SUDOERS(5)
+
+
+       WWWWiiiillllddddccccaaaarrrrddddssss ((((aaaakkkkaaaa mmmmeeeettttaaaa cccchhhhaaaarrrraaaacccctttteeeerrrrssss))))::::
+
+       ssssuuuuddddoooo allows shell-style _w_i_l_d_c_a_r_d_s to be used in pathnames
+       as well as command line arguments in the _s_u_d_o_e_r_s file.
+       Wildcard matching is done via the PPPPOOOOSSSSIIIIXXXX fnmatch(3)
+       routine.  Note that these are _n_o_t regular expressions.
 
        *       Matches any set of zero or more characters.
 
